﻿----------------------------
--      Localization      --
----------------------------

local L = AceLibrary("AceLocale-2.2"):new("MountUp EZDismount")

L:RegisterTranslations("enUS", function() return {
	dismount = true,
	Dismount = true,
	["Options for Dismounting."] = true,

	dazed = true,
	["Clear when Dazed"] = true,
	["Removes Aspect of the Cheetah/Pack when Dazed."] = true,

	taxi = true,
	["Dismount at flightmaster"] = true,
	["Dismounts when the flight map is opened."] = true,

	deshift = true,
	["Deshift on error"] = true,
	["Clears shapeshifts on \"Can't do that when shapeshifted\" errors."] = true,

	dismount = true,
	["Dismount on error"] = true,
	["Dismounts on \"Can't do that when mounted\" errors."] = true,
	["Always dismount"] = true,
	["Dismount except flying"] = true,
	["Dismount when attack the enemy"] = true,
	["Not use dismount"] = true,

	stand = true,
	["Stand on error"] = true,
	["Stand on \"You must be standing to do that\" errors."] = true,
} end)

L:RegisterTranslations("esES", function() return {
	dismount = "desmontar",
	Dismount = "Desmontar",
	["Options for Dismounting."] = "Opciones para Desmontar.",

	dazed = "dazed",
	["Clear when Dazed"] = "Limpiar cuando Aturdido",
	["Removes Aspect of the Cheetah/Pack when Dazed."] = "Elimina el Aspecto de el Cheetah/Pack cuando Aturdido.",

	taxi = "taxi",
	["Dismount at flightmaster"] = "Desmontar en el Maestro de Vuelo",
	["Dismounts when the flight map is opened."] = "Desmonta cuando el mapa de vuelo est\195\161 abierto.",

	deshift = "Quitar Foma",
	["Deshift on error"] = "Quitar Forma en error",
	["Clears shapeshifts on \"Can't do that when shapeshifted\" errors."] = "Limpia Formas en error \"No puedo hacer esto cuando Forma Activa\".",

	dismount = "desmontar",
	["Dismount on error"] = "Desmontar en error",
	["Dismounts on \"Can't do that when mounted\" errors."] = "Desmonta en error \"No puedo hacer esto cuando estoy montado\".",
	["Always dismount"] = "Siempre desmontar",
	["Dismount except flying"] = "Desmonta excepto volando",
	["Dismount when attack the enemy"] = "Desmonta cuando ataque al enemigo",
	["Not use dismount"] = "No utilizar desmontar",

	stand = "permanecer",
	["Stand on error"] = "Permanecer en error",
	["Stand on \"You must be standing to do that\" errors."] = "Permanecer en error \"Deber\195\173as permanecer para hacer esto\".",
} end)

L:RegisterTranslations("koKR", function() return {
	dismount = "내리기",
	Dismount = "탈것 내리기",
	["Options for Dismounting."] = "탈것에서 내리게 하는 옵션입니다.",

	dazed = "멍해짐",
	["Clear when Dazed"] = "멍해짐 시 버프 취소",
	["Removes Aspect of the Cheetah/Pack when Dazed."] = "멍해짐 시 치타의 상이나 치타 무리의 상 버프를 취소합니다.",

	taxi = "비행",
	["Dismount at flightmaster"] = "비행 조련사에서 내리기",
	["Dismounts when the flight map is opened."] = "비행 지도를 열었을 경우 탈것에서 내립니다.",

	deshift = "변신해제",
	["Deshift on error"] = "에러 발생 시 변신해제",
	["Clears shapeshifts on \"Can't do that when shapeshifted\" errors."] = "\"지금은 변신중입니다.\"와 같은 에러 발생 시 변신상태를 해제합니다.",

	dismount = "내리기",
	["Dismount on error"] = "에러 발생 시 내리기",
	["Dismounts on \"Can't do that when mounted\" errors."] = "\"탈것에서 내려야 합니다.\"와 같은 에러 발생 시 탈것에서 내립니다.",
	["Always dismount"] = "항상",
	["Dismount except flying"] = "비행 중일 때는 제외",
	["Dismount when attack the enemy"] = "적을 공격할 때만",
	["Not use dismount"] = "사용하지 않음",

	stand = "일어서기",
	["Stand on error"] = "에러 발생 시 일어서기",
	["Stand on \"You must be standing to do that\" errors."] = "\"먼저 일어서야 합니다.\"와 같은 에러 발생 시 일어섭니다.",
} end)


------------------------------
--      Are you local?      --
------------------------------

local seaura = AceLibrary("SpecialEvents-Aura-2.0")

local _, myclass = UnitClass("player")
local aspects = {
	(GetSpellInfo(13159)), -- Aspect of the Pack
	(GetSpellInfo(5118)), -- Aspect of the Cheetah
}
local standerrors = {
	[ERR_CANTATTACK_NOTSTANDING] = true,
	[ERR_LOOT_NOTSTANDING] = true,
	[ERR_TAXINOTSTANDING] = true,
	[SPELL_FAILED_NOT_STANDING] = true,
}
local mounterrors = {
	[ERR_TAXIPLAYERALREADYMOUNTED] = true,
	[ERR_ATTACK_MOUNTED] = true,
	[SPELL_FAILED_NOT_MOUNTED] = true,
	[SPELL_FAILED_OUT_OF_RANGE] = true,
	[ERR_OUT_OF_RANGE] = true,
	[ERR_PET_SPELL_OUT_OF_RANGE] = true,
}
local shifterrors = {
	[ERR_CANT_INTERACT_SHAPESHIFTED] = true,
	[ERR_MOUNT_SHAPESHIFTED] = true,
	[ERR_NOT_WHILE_SHAPESHIFTED] = true,
	[ERR_NO_ITEMS_WHILE_SHAPESHIFTED] = true,
	[SPELL_FAILED_NOT_SHAPESHIFT] = true,
	[SPELL_FAILED_NO_ITEMS_WHILE_SHAPESHIFTED] = true,
	[SPELL_FAILED_ONLY_UNDERWATER] = true,
	[SPELL_NOT_SHAPESHIFTED] = true,
	[SPELL_NOT_SHAPESHIFTED_NOSPACE] = true,
}


-------------------------------------
--      Namespace Declaration      --
-------------------------------------

MountUpEzDismount = MountUp:NewModule("EZDismount", "AceEvent-2.0", "AceDebug-2.0")
MountUp:RegisterDefaults("EZDismount", "char", {
	taxi = true,
	deshift = true,
	dismount = "ground",
	stand = true,
	clearondaze = true,
})
MountUpEzDismount.db = MountUp:AcquireDBNamespace("EZDismount")
MountUpEzDismount.consoleCmd = L["dismount"]
MountUpEzDismount.consoleOptions = {
	type = "group",
	name = L["Dismount"],
	desc = L["Options for Dismounting."],
	args = {
		[L["taxi"]] = {
			type = "toggle",
			name = L["Dismount at flightmaster"],
			desc = L["Dismounts when the flight map is opened."],
			get = function() return MountUpEzDismount.db.char.taxi end,
			set = function(v) MountUpEzDismount.db.char.taxi = v end,
		},
		[L["dazed"]] = {
			type = "toggle",
			name = L["Clear when Dazed"],
			desc = L["Removes Aspect of the Cheetah/Pack when Dazed."],
			get = function() return MountUpEzDismount.db.char.clearondaze end,
			set = function(v) MountUpEzDismount.db.char.clearondaze = v end,
			hidden = myclass ~= "HUNTER",
		},
		[L["deshift"]] = {
			type = "toggle",
			name = L["Deshift on error"],
			desc = L["Clears shapeshifts on \"Can't do that when shapeshifted\" errors."],
			get = function() return MountUpEzDismount.db.char.deshift end,
			set = function(v) MountUpEzDismount.db.char.deshift = v end,
			hidden = myclass ~= "DRUID" and myclass ~= "PRIEST" and myclass ~= "SHAMAN",
		},
		[L["dismount"]] = {
			type = "text",
			name = L["Dismount on error"],
			desc = L["Dismounts on \"Can't do that when mounted\" errors."],
			get = function() return MountUpEzDismount.db.char.dismount end,
			set = function(v) MountUpEzDismount.db.char.dismount = v end,
			validate = {["always"] = L["Always dismount"], ["ground"] = L["Dismount except flying"], ["enemy"] = L["Dismount when attack the enemy"], ["none"] = L["Not use dismount"]}
		},
		[L["stand"]] = {
			type = "toggle",
			name = L["Stand on error"],
			desc = L["Stand on \"You must be standing to do that\" errors."],
			get = function() return MountUpEzDismount.db.char.stand end,
			set = function(v) MountUpEzDismount.db.char.stand = v end,
		},
	}
}


---------------------------
--      Ace Methods      --
---------------------------

local dazed

function MountUpEzDismount:OnEnable()
	self:RegisterEvent("SpecialEvents_PlayerDebuffGained")
	self:RegisterEvent("TAXIMAP_OPENED")
	self:RegisterEvent("UI_ERROR_MESSAGE")
	dazed = GetSpellInfo(1604)
end


------------------------------
--			Event handling			--
------------------------------

function MountUpEzDismount:UI_ERROR_MESSAGE(msg)
	if UnitOnTaxi("player") then return
	elseif mounterrors[msg] and self.db.char.dismount == "none" then return
	elseif mounterrors[msg] and self.db.char.dismount == "always" then return Dismount()
	elseif mounterrors[msg] and self.db.char.dismount == "ground" and not IsFlying() then return Dismount()
	elseif mounterrors[msg] and self.db.char.dismount == "enemy" and UnitCanAttack("player", "target") then return Dismount()
	elseif shifterrors[msg] and self.db.char.deshift then return self:TriggerEvent("MountUp_Deshift")
	elseif standerrors[msg] and self.db.char.stand then return DoEmote("STAND") end
end


function MountUpEzDismount:TAXIMAP_OPENED()
	if self.db.char.taxi then return Dismount() end
end


function MountUpEzDismount:SpecialEvents_PlayerDebuffGained(debuff)
	if debuff == dazed and self.db.char.clearondaze then
		for _,f in pairs(aspects) do
			local i = seaura:UnitHasBuff("player", f)
			if i then
				i = GetPlayerBuff(i, "HELPFUL")
 				self:Debug("Cancelling ".. f.. " in buff#".. i)
				return CancelPlayerBuff(i)
			end
		end
	end
end
